
/**
 * Title:        <p>
 * Description:  <p>
 * Copyright:    Copyright (c) <p>
 * Company:      <p>
 * @author
 * @version 1.0
 */
package vishnu.testvis.visual;

import javax.swing.*;
import java.awt.*;
import javax.swing.border.*;
import java.awt.event.*;

public class ListPanel extends JPanel
{
    JList documentsList = new JList();
    BorderLayout borderLayout1 = new BorderLayout();
    Border border1;
    JLabel descriptionLabel = new JLabel();
    Vishnu displayFrame;
    JPanel southPanel = new JPanel();
    JButton fetchButton = new JButton();

    public ListPanel()
    {
        displayFrame=null;
        try
        {
            jbInit();
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }

    public ListPanel(Vishnu d)
    {
        displayFrame=d;
        try
        {
            jbInit();
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }

    private void jbInit() throws Exception
    {
        border1 = BorderFactory.createEmptyBorder(10,10,10,10);
        this.setLayout(borderLayout1);
        this.setBorder(border1);
        descriptionLabel.setFont(new java.awt.Font("Monospaced", 0, 14));
        descriptionLabel.setText("Document descriptions");
        documentsList.setFont(new java.awt.Font("Monospaced", 0, 12));
        documentsList.setToolTipText("");
        documentsList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        documentsList.setVisibleRowCount(10);
        documentsList.addMouseListener(new java.awt.event.MouseAdapter()
        {

            public void mouseClicked(MouseEvent e)
            {
                documentsList_mouseClicked(e);
            }
        });
        fetchButton.setFont(new java.awt.Font("Monospaced", 0, 16));
        fetchButton.setBorder(BorderFactory.createEtchedBorder());
        fetchButton.setText("Fetch");
        fetchButton.addMouseListener(new java.awt.event.MouseAdapter()
        {

            public void mouseClicked(MouseEvent e)
            {
                fetchButton_mouseClicked(e);
            }
        });
        this.add(documentsList, BorderLayout.CENTER);
        this.add(descriptionLabel, BorderLayout.NORTH);
        this.add(southPanel, BorderLayout.SOUTH);
        southPanel.add(fetchButton, null);
    }

    public void update()
    {
       documentsList.setListData(displayFrame.dataManager.getDescriptions());
       repaint();
    }

    void documentsList_mouseClicked(MouseEvent e)
    {
        int index = documentsList.getSelectedIndex();
        if (index >=0)
            displayFrame.dataManager.fetch(index);
    }

    void fetchButton_mouseClicked(MouseEvent e)
    {
        int index = documentsList.getSelectedIndex();
        if (index >=0)
            displayFrame.dataManager.fetch(index);
    }

    void fetchButton_mouseEntered(MouseEvent e)
    {

    }

    void fetchButton_mouseExited(MouseEvent e)
    {

    }

    void fetchButton_mousePressed(MouseEvent e)
    {

    }

    void fetchButton_mouseReleased(MouseEvent e)
    {

    }
}
